//#include "BasicGraphicList.h"
#include "ModelTypeList.h"
#include "ModelType.h"
#include "BasicGraphicList.h"
#include "globals.h"
//#include "RenderEngine.h"
//extern RenderEngine* renderEngine;

struct typeNameEntry{
	char *name; 
	int num;
	Part parts[10];
	
};

//update the TYPENAMELENGTH field in globals.h

static typeNameEntry  typeNames []={
	//Players=0 to 4
	{"Player1",1,{{"leet.xp",{0,0,-2},{0,0,0},0.07}}},
	{"Player1",1,{{"leet.xp",{0,0,-2},{0,0,0},0.07}}},
	{"Player1",1,{{"leet.xp",{0,0,-2},{0,0,0},0.07}}},
	{"Player1",1,{{"leet.xp",{0,0,-2},{0,0,0},0.07}}},
	{"Player1",1,{{"leet.xp",{0,0,-2},{0,0,0},0.07}}},	
	//{"Player2",1,{{"samurai.xp",{0,0,0},{0,0,0},1.0}}},
	//{"Player3",1,{{"marine.xp",{0,0,0},{0,0,0},1.0}}},
	//{"Player4",3,{{"sargeHead.xp",{0,0,2.0},{0,0,0},1},{"sargeUpper.xp",{0,0,1.75},{-25,-30,0},1.5},{"sargeLower.xp",{0,0,0},{0,60,0},2}}},
	//{"Player5",1,{{"leet.xp",{0,0,-1},{0,0,0},0.05}}},
	
	//Ammo 5 to 7
	{"Ammo1",1,{{"ammo1.xp",{0,0,0},{0,0,0},1.0}}},
	{"Ammo2",1,{{"ammo2.xp",{0,0,0},{0,0,0},1.0}}},
	{"Ammo3",1,{{"ammo3.xp",{0,0,0},{0,0,0},1.0}}},

	//Projectiles 8 to 10
	{"Bullet1",1,{{"bullet.xp",{0,0,0},{0,0,180},0.1}}},
	{"Bullet2",1,{{"bullet.xp",{0,0,0},{0,0,180},0.1}}},
	{"Bullet3",1,{{"rocket.xp",{0,0,0},{0,0,0},1.0}}},
	
	//Guns =11 to 13
	{"Gun1",1,{{"pistol.xp",{0,0,-3},{0,0,0},0.1}}},
	{"Gun2",1,{{"pag.xp",{0,0,-3},{0,0,0},0.1}}},
	{"Gun3",1,{{"rocketl.xp",{0,0,2},{0,0,0},2.00}}},

	//Powerups 14 to 16
	{"IRGlass",1,{{"sargeHead.xp",{0,0,0},{0,0,0},1.0}}},
	{"Matrix",1,{{"matrixcan.xp",{0,0,-3},{0,0,180},0.1}}},
	{"Health",1,{{"sargeLower.xp",{0,0,0},{0,0,180},1.0}}}	
};


bool ModelTypeList::initList(BasicGraphicList *basicGraphicList){
	ModelType *modelType;
	bool success=true;
	for(int i=0;i<( sizeof(typeNames)/sizeof(typeNameEntry));i++){
		modelType=new ModelType(typeNames[i].name);
		Part *partArray=typeNames[i].parts;
		int numParts=typeNames[i].num;;
		modelType->setNumParts(numParts);
		for(int j=0;j<numParts;j++){
			int index=basicGraphicList->getIndex(partArray[j].name);
			modelType->setPart(j,index,&partArray[j]);
		}
		
		modelTypeVector.push_back(modelType);
	}
	return success;


}

void ModelTypeList::freeList(){
	std::vector<ModelType *>::iterator iter=modelTypeVector.begin();
	while(iter != modelTypeVector.end()){
		delete *iter;
		iter++;
	}
	modelTypeVector.clear();
}

ModelType *ModelTypeList::getModelType(int index){
	return modelTypeVector[index];
}

int ModelTypeList::getLength(){
	return modelTypeVector.size();
}

int ModelTypeList::getIndex(const char *name){
	std::vector<ModelType *>::iterator iter=modelTypeVector.begin();
	int i=0;
	while(iter != modelTypeVector.end()){
		if(strcmp((*iter)->getName(),name)==0){
			return i;
		}
		iter++;
		i++;
	}

	return -1;

}

ModelTypeList::~ModelTypeList(){
	freeList();

}

ModelTypeList::ModelTypeList(){
}

ModelType *ModelTypeList::getModelType(const char* name){

	std::vector<ModelType *>::iterator iter=modelTypeVector.begin();
	while(iter != modelTypeVector.end()){
		if(strcmp((*iter)->getName(),name)==0){
			return *iter;
		}
		iter++;
	}

	return NULL;
}
